//-------------------------------------------------------------
//  SheriffOnline.com - Free MQL Code Service
//-------------------------------------------------------------
// Keywords: MT4, create EA, expert advisor developer

#property copyright "Copyright  2013, SheriffOnline.com - Free MQL Code Service"
#property link      "http://www.sheriffonline.com/"

#include <stdlib.mqh>
#include <WinUser32.mqh>

// exported variables
extern int TrailingStop1 = 12;
extern int NewTakeProfit1 = 200;
extern int TrailingGap1 = 7;
extern int HoursFrom32 = 1;
extern int HoursTo32 = 23;
extern double BuyLots36 = 0.1;
extern int BuyStoploss36 = 200;
extern int BuyTakeprofit36 = 300;
extern double SellLots35 = 0.1;
extern int SellStoploss35 = 200;
extern int SellTakeprofit35 = 300;


// local variables
double PipValue=1;    // this variable is here to support 5-digit brokers
bool Terminated = false;
string LF = "\n";  
int NDigits = 4;   
int ObjCount = 0;  
int current = 0;

int Count34 = 0;


int init()
{
    NDigits = Digits;
    
    if (false) ObjectsDeleteAll();      
    
    
    Comment("");    
}

// Expert start
int start()
{
    if (Bars < 10)
    {
        Comment("Not enough bars");
        return (0);
    }
    if (Terminated == true)
    {
        Comment("EA Terminated.");
        return (0);
    }
    
    OnEveryTick33();
    
}

void OnEveryTick33()
{
    if (true == false && false) PipValue = 10;
    if (true && (NDigits == 3 || NDigits == 5)) PipValue = 10;
    
    PrintInfoToChart34();
    TrailingStop1();
    IfOrderExists26();
    IfOrderExists20();
    HoursFilter32();
    
}

void PrintInfoToChart34()
{
    string temp = "SheriffOnline.com - Free MQL Code Service\nExecuted : " + Count34 + "\n"
    + "Spread: " + DoubleToStr(MarketInfo(Symbol(), MODE_SPREAD)/PipValue, 2)+ "\n"
    + "------------------------------------------------\n"
    + "ACCOUNT INFORMATION:\n"
    + "\n"
    + "Account Name:     " + AccountName()+ "\n"
    + "Account Leverage:     " + DoubleToStr(AccountLeverage(), 0)+ "\n"
    + "Account Balance:     " + DoubleToStr(AccountBalance(), 2)+ "\n"
    + "Account Equity:     " + DoubleToStr(AccountEquity(), 2)+ "\n"
    + "Free Margin:     " + DoubleToStr(AccountFreeMargin(), 2)+ "\n"
    + "Used Margin:     " + DoubleToStr(AccountMargin(), 2)+ "\n"
    + "------------------------------------------------\n";
    Comment(temp);
    Count34++;
    
}

void TrailingStop1()
{
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderSymbol() == Symbol() && OrderMagicNumber() == 1)
        {
            double takeprofit = OrderTakeProfit();
            
            if (OrderType() == OP_BUY && Ask - OrderOpenPrice() > TrailingStop1*PipValue*Point)
            {
                if (OrderStopLoss() < Ask-(TrailingStop1+TrailingGap1)*PipValue*Point)
                {
                    if (NewTakeProfit1 != 0) takeprofit = Ask+(NewTakeProfit1 + TrailingStop1)*PipValue*Point;
                    bool ret1 = OrderModify(OrderTicket(), OrderOpenPrice(), Ask-TrailingStop1*PipValue*Point, takeprofit, OrderExpiration(), White);
                    if (ret1 == false)
                    Print("OrderModify() error - ", ErrorDescription(GetLastError()));
                }
            }
            if (OrderType() == OP_SELL && OrderOpenPrice() - Bid > TrailingStop1*PipValue*Point)
            {
                if (OrderStopLoss() > Bid+(TrailingStop1+TrailingGap1)*PipValue*Point)
                {
                    if (NewTakeProfit1 != 0) takeprofit = Bid-(NewTakeProfit1 + TrailingStop1)*PipValue*Point;
                    bool ret2 = OrderModify(OrderTicket(), OrderOpenPrice(), Bid+TrailingStop1*PipValue*Point, takeprofit, OrderExpiration(), White);
                    if (ret2 == false)
                    Print("OrderModify() error - ", ErrorDescription(GetLastError()));
                }
            }
        }
    }
    else
    Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    
}

void IfOrderExists26()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OP_BUY && OrderSymbol() == Symbol() && OrderMagicNumber() == 1)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists)
    {
        TechnicalAnalysis2x25();
        
    }
}

void TechnicalAnalysis2x25()
{
    if ((iSAR(NULL, NULL,0.02,0.2,1) > High[0]) && (Close[1] < iMA(NULL, NULL,20,0,MODE_SMA,PRICE_CLOSE,0)))
    {
        CloseOrder38();
        
    }
}

void CloseOrder38()
{
    int orderstotal = OrdersTotal();
    int orders = 0;
    int ordticket[30][2];
    for (int i = 0; i < orderstotal; i++)
    {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderType() != OP_BUY || OrderSymbol() != Symbol() || OrderMagicNumber() != 1)
        {
            continue;
        }
        ordticket[orders][0] = OrderOpenTime();
        ordticket[orders][1] = OrderTicket();
        orders++;
    }
    if (orders > 1)
    {
        ArrayResize(ordticket,orders);
        ArraySort(ordticket);
    }
    for (i = 0; i < orders; i++)
    {
        if (OrderSelect(ordticket[i][1], SELECT_BY_TICKET) == true)
        {
            bool ret = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 4, Red);
            if (ret == false)
            Print("OrderClose() error - ", ErrorDescription(GetLastError()));
        }
    }
    
}

void IfOrderExists20()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OP_SELL && OrderSymbol() == Symbol() && OrderMagicNumber() == 1)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists)
    {
        TechnicalAnalysis2x19();
        
    }
}

void TechnicalAnalysis2x19()
{
    if ((iSAR(NULL, NULL,0.02,0.2,1) < Low[0]) && (Close[1] > iMA(NULL, NULL,20,0,MODE_SMA,PRICE_CLOSE,0)))
    {
        CloseOrder37();
        
    }
}

void CloseOrder37()
{
    int orderstotal = OrdersTotal();
    int orders = 0;
    int ordticket[30][2];
    for (int i = 0; i < orderstotal; i++)
    {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderType() != OP_SELL || OrderSymbol() != Symbol() || OrderMagicNumber() != 1)
        {
            continue;
        }
        ordticket[orders][0] = OrderOpenTime();
        ordticket[orders][1] = OrderTicket();
        orders++;
    }
    if (orders > 1)
    {
        ArrayResize(ordticket,orders);
        ArraySort(ordticket);
    }
    for (i = 0; i < orders; i++)
    {
        if (OrderSelect(ordticket[i][1], SELECT_BY_TICKET) == true)
        {
            bool ret = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 4, Red);
            if (ret == false)
            Print("OrderClose() error - ", ErrorDescription(GetLastError()));
        }
    }
    
}

void HoursFilter32()
{
    int datetime800 = TimeLocal();
    int hour0 = TimeHour(datetime800);
    
    if ((HoursFrom32 < HoursTo32 && hour0 >= HoursFrom32 && hour0 < HoursTo32) ||
    (HoursFrom32 > HoursTo32 && (hour0 < HoursTo32 || hour0 >= HoursFrom32)))
    {
        IfOrderDoesNotExist24();
        IfOrderDoesNotExist31();
        
    }
}

void IfOrderDoesNotExist24()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OP_BUY && OrderSymbol() == Symbol() && OrderMagicNumber() == 1)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists == false)
    {
        TechnicalAnalysis3x23();
        
    }
}

void TechnicalAnalysis3x23()
{
    if ((iSAR(NULL, NULL,0.02,0.2,2) < iBands(NULL, NULL,20,1.65,0,PRICE_CLOSE,MODE_LOWER,0)) && (Close[2] < iMA(NULL, NULL,20,0,MODE_SMA,PRICE_CLOSE,0)) && (iSAR(NULL, NULL,0.02,0.2,1) < iBands(NULL, NULL,20,1.65,0,PRICE_CLOSE,MODE_LOWER,0)))
    {
        TechnicalAnalysis3x22();
        
    }
}

void TechnicalAnalysis3x22()
{
    if ((Close[1] > Open[0]) && (Close[1] > iMA(NULL, NULL,20,0,MODE_SMA,PRICE_CLOSE,0)) && (Open[0] > iMA(NULL, NULL,20,0,MODE_SMA,PRICE_CLOSE,0)))
    {
        TechnicalAnalysis2x21();
        
    }
}

void TechnicalAnalysis2x21()
{
    if ((iADX(NULL, NULL,14,PRICE_CLOSE,MODE_PLUSDI,0) > 20) && (iATR(NULL, NULL,14,0) >= 0.0005))
    {
        BuyOrder36();
        
    }
}

void BuyOrder36()
{
    double SL = Ask - BuyStoploss36*PipValue*Point;
    if (BuyStoploss36 == 0) SL = 0;
    double TP = Ask + BuyTakeprofit36*PipValue*Point;
    if (BuyTakeprofit36 == 0) TP = 0;
    int ticket = -1;
    if (true)
    ticket = OrderSend(Symbol(), OP_BUY, BuyLots36, Ask, 4, 0, 0, "SheriffOnline.com - Free MQL Code Service", 1, 0, Blue);
    else
    ticket = OrderSend(Symbol(), OP_BUY, BuyLots36, Ask, 4, SL, TP, "SheriffOnline.com - Free MQL Code Service", 1, 0, Blue);
    if (ticket > -1)
    {
        if (true)
        {
            OrderSelect(ticket, SELECT_BY_TICKET);
            bool ret = OrderModify(OrderTicket(), OrderOpenPrice(), SL, TP, 0, Blue);
            if (ret == false)
            Print("OrderModify() error - ", ErrorDescription(GetLastError()));
        }
            
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
}

void IfOrderDoesNotExist31()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OP_SELL && OrderSymbol() == Symbol() && OrderMagicNumber() == 1)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists == false)
    {
        TechnicalAnalysis3x18();
        
    }
}

void TechnicalAnalysis3x18()
{
    if ((iSAR(NULL, NULL,0.02,0.2,2) > iBands(NULL, NULL,20,1.65,0,PRICE_CLOSE,MODE_LOWER,0)) && (Close[2] < iMA(NULL, NULL,20,0,MODE_SMA,PRICE_CLOSE,0)) && (iSAR(NULL, NULL,0.02,0.2,1) > iBands(NULL, NULL,20,1.65,0,PRICE_CLOSE,MODE_LOWER,0)))
    {
        TechnicalAnalysis3x17();
        
    }
}

void TechnicalAnalysis3x17()
{
    if ((Close[1] < Open[0]) && (Close[1] < iMA(NULL, NULL,20,0,MODE_SMA,PRICE_CLOSE,0)) && (Open[0] < iMA(NULL, NULL,20,0,MODE_SMA,PRICE_CLOSE,0)))
    {
        TechnicalAnalysis2x16();
        
    }
}

void TechnicalAnalysis2x16()
{
    if ((iADX(NULL, NULL,14,PRICE_CLOSE,MODE_MINUSDI,0) > 20) && (iATR(NULL, NULL,14,0) >= 0.0005))
    {
        SellOrder35();
        
    }
}

void SellOrder35()
{
    double SL = Bid + SellStoploss35*PipValue*Point;
    if (SellStoploss35 == 0) SL = 0;
    double TP = Bid - SellTakeprofit35*PipValue*Point;
    if (SellTakeprofit35 == 0) TP = 0;
    int ticket = -1;
    if (true)
    ticket = OrderSend(Symbol(), OP_SELL, SellLots35, Bid, 4, 0, 0, "SheriffOnline.com - Free MQL Code Service", 1, 0, Red);
    else
    ticket = OrderSend(Symbol(), OP_SELL, SellLots35, Bid, 4, SL, TP, "SheriffOnline.com - Free MQL Code Service", 1, 0, Red);
    if (ticket > -1)
    {
        if (true)
        {
            OrderSelect(ticket, SELECT_BY_TICKET);
            bool ret = OrderModify(OrderTicket(), OrderOpenPrice(), SL, TP, 0, Red);
            if (ret == false)
            Print("OrderModify() error - ", ErrorDescription(GetLastError()));
        }
            
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
}



int deinit()
{
    if (false) ObjectsDeleteAll();
    
    
}


